
## Version Control

We exclusively use `git` in RDD. Please see <https://git-scm.com/doc> for information on how it works.

We recommend to use the [Git flow
Workflow](https://www.atlassian.com/git/tutorials/comparing-workflows/gitflow-workflow) (also consult the [Cheat
Sheet](https://danielkummer.github.io/git-flow-cheatsheet)).

For using `git flow` it is safest to protect your `master` and `develop` branch on server side to avoid accidental
pushes into these branches. All specific branches working on an issue described in a bug tracker may utilize the
following naming scheme:\
\
`[track]/#[ISSUENUMBER]-[KEYWORD]`\
\
e.g. `bugfix/#12-flux-capacitor`.

A GitHub workflow used in DARIAH-DE and related services is described in the [DARIAH-DE
Wiki](https://wiki.de.dariah.eu/display/DARIAH3/DARIAH-DE+Release+Management#DARIAH-DEReleaseManagement-Beispielmitdevelop-undmaster-Branch(Gitflow)).

You could also use the [GitLab flow](https://docs.gitlab.com/ee/topics/gitlab_flow.html) as a simpler alternative,
which can be broken down into [11 Rules](https://about.gitlab.com/blog/2016/07/27/the-11-rules-of-gitlab-flow/).

It is also recommended to automatically close issues via commit message; How this works exactly depends on the Git
repository server. Issues can also be [referenced across
repositories](https://help.github.com/articles/autolinked-references-and-urls/#commit-shas).

We use the following Git servers at the moment in RDD:

- Projects (GWDG) --> <https://projects.gwdg.de>
- GitLab (GWDG) --> <https://gitlab.gwdg.de>
- github.org --> <https://github.com/subugoe>

Which one is suitable for you depends on:

- the project you are working on
- existing code
- whether or not you want to use CI/CD or GitLab Runners
- ...

We have got an [RDD team on GitHub](https://github.com/orgs/subugoe/teams/fe). Feel free to join us!

Consider mirroring of repos for project visibility (e.g. mirror GitLab/Projects code to GitHub?)
